<script setup lang="ts">
import {
  Blog,
  ArrowRight,
  Ebook,
  Report,
  ChevronLgRight,
  Institution,
  RemoteWorldAlt,
  PiggyBankAlt,
  CogCheck,
} from 'slippers-ui/icons';
import type { BaseCard, BaseLink } from '@/types/base';

const icons = {
  Blog,
  Ebook,
  Report,
  Institution,
  RemoteWorldAlt,
  PiggyBankAlt,
  CogCheck,
};

interface ResourcesProps {
  title?: string;
  subtitle?: string;
  button?: BaseLink;
  cards?: BaseCard[];
  config?: {
    background?: string;
  };
}

defineProps<ResourcesProps>();
</script>

<template>
  <section class="resources" :class="{ 'background-purple': config?.background === 'purple' }">
    <SlpContainer>
      <SlpTypography tag="h3" variant="heading3-bold">{{ title }}</SlpTypography>
      <div class="resources__header">
        <SlpTypography v-if="subtitle" tag="p" variant="heading5" class="slp-mt-8">{{ subtitle }}</SlpTypography>
        <SlpButton
          v-if="button"
          :href="button.config.href"
          :data-ga-name="button.config.dataGaName"
          :data-ga-location="button.config.dataGaLocation"
          :icon="button.config.icon"
          variant="tertiary"
          >{{ button.text }}<SlpIcon :icon="ChevronLgRight" alt=""
        /></SlpButton>
      </div>
      <SlpRow class="resources__row slp-mt-48">
        <SlpColumn v-for="card in cards" :key="card.title" :cols="4" class="resources__card">
          <a
            :href="card.config.url"
            :data-ga-name="card.config.dataGaName"
            :data-ga-location="card.config.dataGaLocation"
          >
            <SlpIcon
              :icon="icons[card.config.icon]"
              alt=""
              size="md"
              color="black"
              class="slp-mb-16"
              variant="marketing"
            />
            <SlpTypography tag="h4" variant="body1-bold" class="slp-mb-16">{{ card.title }}</SlpTypography>
            <SlpTypography tag="p" variant="body3" class="slp-mb-24 resources__card-description">
              {{ card.description }}
            </SlpTypography>
            <SlpIcon :icon="ArrowRight" variant="product" hex-color="link-100" />
          </a>
        </SlpColumn>
      </SlpRow>
    </SlpContainer>
  </section>
</template>

<style lang="scss" scoped>
.resources {
  padding: $spacing-96 0;
  @media (max-width: $breakpoint-md) {
    padding: $spacing-64 0;
  }

  &.background-purple {
    background-color: $color-surface-800;
  }

  &__header {
    display: flex;
    justify-content: space-between;
    align-items: center;

    @media (max-width: $breakpoint-md) {
      flex-direction: column;
      align-items: flex-start;
    }
  }

  &__row {
    justify-content: space-between;
    display: flex;
    align-items: stretch;

    @media (max-width: $breakpoint-md) {
      flex-wrap: nowrap;
      overflow-x: auto;
      justify-content: flex-start;
      padding-bottom: $spacing-16;
      -webkit-overflow-scrolling: touch;

      &::-webkit-scrollbar {
        display: none;
      }
      -ms-overflow-style: none;
      scrollbar-width: none;
    }
  }

  &__card-description {
    color: $color-text-200;
  }

  &__card {
    max-width: 340px;
    display: flex;

    @media (max-width: $breakpoint-md) {
      margin-bottom: 0;
      margin-right: $spacing-16;
      min-width: 280px;

      &:last-child {
        margin-right: 0;
      }
    }

    a {
      color: $color-text-300;
      padding: $spacing-32 $spacing-16 $spacing-24;
      display: flex;
      flex-direction: column;
      width: 100%;
      background: $color-surface-50;
      justify-content: space-between;

      .slp-btn {
        color: $color-text-link-100;
        margin-top: auto;
        text-align: left;
        &:hover {
          text-decoration: none;
        }
      }

      &:hover {
        box-shadow: $shadow-surface-primary-3;
        border-radius: $spacing-4 $spacing-4 $spacing-96 $spacing-4;
        transition: all 0.3s ease-in-out;
        cursor: pointer;
      }
    }
  }
}
</style>
